<?xml version="1.0" encoding="UTF-8"?><!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd"><html xmlns="http://www.w3.org/1999/xhtml" lang="fr"><head><meta http-equiv="Content-Type" content="text/html;charset=UTF-8"/><link rel="stylesheet" href="../.resources/report.css" type="text/css"/><link rel="shortcut icon" href="../.resources/report.gif" type="image/gif"/><title>Game.java</title><link rel="stylesheet" href="../.resources/prettify.css" type="text/css"/><script type="text/javascript" src="../.resources/prettify.js"></script></head><body onload="window['PR_TAB_WIDTH']=4;prettyPrint()"><div class="breadcrumb" id="breadcrumb"><span class="info"><a href="../.sessions.html" class="el_session">Sessions</a></span><a href="../index.html" class="el_report">JaCoCoverage analysis of project &quot;ATL-OTHELLO-Monir&quot; (powered by JaCoCo from EclEmma)</a> &gt; <a href="index.source.html" class="el_package">esi.atl.othello.monir.model</a> &gt; <span class="el_source">Game.java</span></div><h1>Game.java</h1><pre class="source lang-java linenums">package esi.atl.othello.monir.model;

import java.util.Arrays;
import java.util.Collections;
import java.util.List;

/**
 * This class represents the facade of the game.
 *
 * @author Monir Nasser
 */
public class Game implements Model {

    private Board board;
    private Player current;
    private Player opponent;
<span class="fc" id="L17">    private final int NB_PCS0 = 1;</span>
<span class="fc" id="L18">    private final int NB_PCS1 = 20;</span>
<span class="fc" id="L19">    private final int NB_PCS2 = 10;</span>
<span class="fc" id="L20">    private final int NB_PCS3 = 1;</span>
<span class="fc" id="L21">    private final int MAX_POINTS = (NB_PCS1 + NB_PCS2 * 2 + NB_PCS3 * 3) * 2;</span>

    /**
     * This method construct the Game.
     */
<span class="fc" id="L26">    public Game() {</span>
<span class="fc" id="L27">        this.board = null;</span>
<span class="fc" id="L28">        this.current = new Player(PlayerColor.BLACK);</span>
<span class="fc" id="L29">        this.opponent = new Player(PlayerColor.WHITE);</span>

<span class="fc" id="L31">    }</span>

    /**
     * This method initialize the game and pose 2 pieces black and 2 white.
     */
    @Override
    public void initialize() {
<span class="fc" id="L38">        board = new Board();</span>
<span class="fc" id="L39">        board.put(new Piece(PlayerColor.BLACK, 1), new Position(3, 4));</span>
<span class="fc" id="L40">        board.put(new Piece(PlayerColor.BLACK, 1), new Position(4, 3));</span>
<span class="fc" id="L41">        board.put(new Piece(PlayerColor.WHITE, 1), new Position(3, 3));</span>
<span class="fc" id="L42">        board.put(new Piece(PlayerColor.WHITE, 1), new Position(4, 4));</span>

<span class="fc bfc" id="L44" title="All 2 branches covered.">        for (int i = 0; i &lt; NB_PCS2; i++) {</span>
<span class="fc" id="L45">            current.addPiece(new Piece(PlayerColor.BLACK, 2));</span>
<span class="fc" id="L46">            opponent.addPiece(new Piece(PlayerColor.WHITE, 2));</span>
        }
<span class="fc bfc" id="L48" title="All 2 branches covered.">        for (int i = 0; i &lt; NB_PCS1 - 2; i++) {</span>
<span class="fc" id="L49">            current.addPiece(new Piece(PlayerColor.BLACK, 1));</span>
<span class="fc" id="L50">            opponent.addPiece(new Piece(PlayerColor.WHITE, 1));</span>
        }

<span class="fc" id="L53">        current.addPiece(new Piece(PlayerColor.BLACK, 3));</span>
<span class="fc" id="L54">        current.addPiece(new Piece(PlayerColor.BLACK, 0));</span>
<span class="fc" id="L55">        opponent.addPiece(new Piece(PlayerColor.WHITE, 3));</span>
<span class="fc" id="L56">        opponent.addPiece(new Piece(PlayerColor.WHITE, 0));</span>

<span class="fc" id="L58">        current.shuffleList();</span>
<span class="fc" id="L59">        opponent.shuffleList();</span>
<span class="fc" id="L60">    }</span>

    /**
     * This method start the game and check if the board is null or the game is
     * over.
     */
    @Override
    public void start() {
<span class="pc bpc" id="L68" title="1 of 2 branches missed.">        if (board == null) {</span>
<span class="fc" id="L69">            throw new IllegalStateException(&quot;board is not defined&quot;);</span>
        }
<span class="nc bnc" id="L71" title="All 2 branches missed.">        if (isOver()) {</span>
<span class="nc" id="L72">            throw new IllegalStateException(&quot;board is over&quot;);</span>
        }
<span class="nc" id="L74">    }</span>

    /**
     * This method check if the game is over.
     *
     * @return A boolean.
     */
    @Override
    public boolean isOver() {
<span class="fc bfc" id="L83" title="All 4 branches covered.">        return isBoardFull() || !hasMoves2Players();</span>
    }

    /**
     * This method check if the board is full.
     *
     * @return true if is full.
     */
    public boolean isBoardFull() {
<span class="fc" id="L92">        boolean isFull = true;</span>
<span class="fc bfc" id="L93" title="All 2 branches covered.">        if (current.getPoints() + opponent.getPoints() != MAX_POINTS) {</span>
<span class="fc" id="L94">            isFull = false;</span>
        }
<span class="fc" id="L96">        return isFull;</span>
    }

    /**
     * This method put the piece at the position given in parameter.
     *
     * @param position Position.
     */
    public void putPiece(Position position) {
<span class="fc bfc" id="L105" title="All 2 branches covered.">        if (position == null) {</span>
<span class="fc" id="L106">            throw new IllegalArgumentException(&quot;the position is null&quot;);</span>
        }
<span class="pc bpc" id="L108" title="1 of 2 branches missed.">        if (isValidMoveAllDirection(position)) {</span>
<span class="fc" id="L109">            this.board.put(current.getPiece(), position);</span>
<span class="fc" id="L110">            this.current.removePiece();</span>
<span class="fc" id="L111">            eatPiecesAllDirection(position);</span>
        }
<span class="fc" id="L113">        swapPlayers();</span>
<span class="fc" id="L114">    }</span>

    /**
     * This method returns us the value of black and white pieces in the board.
     *
     * @return A tab of integer.
     */
    public int[] valuePieces() {
<span class="fc" id="L122">        int[] values = new int[2];</span>
<span class="fc" id="L123">        values[0] = current.getPoints();</span>
<span class="fc" id="L124">        values[1] = opponent.getPoints();</span>
<span class="fc" id="L125">        return values;</span>
    }

    /**
     * This method check if the piece given in parameter is black.
     *
     * @param piece The piece we need to test.
     * @return true or false.
     */
    public boolean coloredPieceBlack(Piece piece) {
<span class="fc bfc" id="L135" title="All 2 branches covered.">        return PlayerColor.BLACK == piece.getColor();</span>
    }

    /**
     * This method check if the 2 players has moves.
     *
     * @return true or false.
     */
    public boolean hasMoves2Players() {
<span class="fc" id="L144">        boolean hasMoves = false;</span>
<span class="fc" id="L145">        int row = 0;</span>
<span class="fc bfc" id="L146" title="All 4 branches covered.">        while (!hasMoves &amp;&amp; row &lt; board.getNB_ROW()) {</span>
<span class="fc" id="L147">            int col = 0;</span>
<span class="fc bfc" id="L148" title="All 4 branches covered.">            while (!hasMoves &amp;&amp; col &lt; board.getNB_COLUMN()) {</span>
<span class="fc" id="L149">                Position position = new Position(row, col);</span>
<span class="fc bfc" id="L150" title="All 2 branches covered.">                if (board.isFree(position)) {</span>
<span class="fc bfc" id="L151" title="All 2 branches covered.">                    if (isValidMoveAllDirection(position)) {</span>
<span class="fc" id="L152">                        hasMoves = true;</span>
                    }
                }
<span class="fc" id="L155">                col++;</span>
<span class="fc" id="L156">            }</span>
<span class="fc" id="L157">            row++;</span>
<span class="fc" id="L158">        }</span>
<span class="fc bfc" id="L159" title="All 2 branches covered.">        if (!hasMoves) {</span>
<span class="fc" id="L160">            hasMoves = hasMovesOpponentPlayer();</span>
        }
<span class="fc" id="L162">        return hasMoves;</span>
    }

    /**
     * This method check if the oppenent player has moves.
     *
     * @return true or false.
     */
    public boolean hasMovesOpponentPlayer() {
<span class="fc" id="L171">        swapPlayers();</span>
<span class="fc" id="L172">        boolean hasMoves = false;</span>
<span class="fc" id="L173">        int row = 0;</span>
<span class="fc bfc" id="L174" title="All 4 branches covered.">        while (!hasMoves &amp;&amp; row &lt; board.getNB_ROW()) {</span>
<span class="fc" id="L175">            int col = 0;</span>
<span class="fc bfc" id="L176" title="All 4 branches covered.">            while (!hasMoves &amp;&amp; col &lt; board.getNB_COLUMN()) {</span>
<span class="fc" id="L177">                Position position = new Position(row, col);</span>
<span class="fc bfc" id="L178" title="All 2 branches covered.">                if (board.isFree(position)) {</span>
<span class="fc bfc" id="L179" title="All 2 branches covered.">                    if (isValidMoveAllDirection(position)) {</span>
<span class="fc" id="L180">                        hasMoves = true;</span>
                    }
                }
<span class="fc" id="L183">                col++;</span>
<span class="fc" id="L184">            }</span>
<span class="fc" id="L185">            row++;</span>
<span class="fc" id="L186">        }</span>
<span class="fc" id="L187">        swapPlayers();</span>
<span class="fc" id="L188">        return hasMoves;</span>
    }

    /**
     * This method verify if the move is valid in the direction given in
     * parameter.
     *
     * @param position The position start
     * @param direction The direction we will go.
     * @return True if is valid.
     */
    public boolean isValidMove(Position position, Direction direction) {
<span class="fc" id="L200">        boolean hasMove = false;</span>
<span class="fc" id="L201">        Position pos = new Position(position.getRow(), position.getColumn());</span>
<span class="fc" id="L202">        pos.next(direction);</span>
<span class="fc bfc" id="L203" title="All 2 branches covered.">        if (board.isInside(pos)) {</span>
<span class="fc bfc" id="L204" title="All 2 branches covered.">            if (!board.isFree(pos)) {</span>
<span class="fc bfc" id="L205" title="All 2 branches covered.">                if (board.getPiece(pos).getColor() != current.getColor()) {</span>
<span class="fc bfc" id="L206" title="All 6 branches covered.">                    while (!hasMove &amp;&amp; board.isInside(pos) &amp;&amp; !board.isFree(pos)) {</span>
<span class="fc bfc" id="L207" title="All 2 branches covered.">                        if (board.getPiece(pos).getColor() == current.getColor()) {</span>
<span class="fc" id="L208">                            hasMove = true;</span>
                        }
<span class="fc" id="L210">                        pos.next(direction);</span>
                    }
                }
            }
        }
<span class="fc" id="L215">        return hasMove;</span>
    }

    /**
     * This method verify the move in all directions.
     *
     * @param position The position star.
     * @return true if one direction is valid.
     */
    public boolean isValidMoveAllDirection(Position position) {
<span class="fc" id="L225">        boolean hasMoves = false;</span>
<span class="fc" id="L226">        List&lt;Direction&gt; listDirection = Arrays.asList(Direction.UP,</span>
                Direction.DOWN, Direction.UPLEFT,
                Direction.LEFT, Direction.DOWNLEFT,
                Direction.RIGHT, Direction.DOWNRIGTH,
                Direction.UPRIGTH);
<span class="fc" id="L231">        int i = 0;</span>
<span class="fc bfc" id="L232" title="All 4 branches covered.">        while (!hasMoves &amp;&amp; i &lt; listDirection.size()) {</span>
<span class="fc bfc" id="L233" title="All 2 branches covered.">            if (isValidMove(position, listDirection.get(i))) {</span>
<span class="fc" id="L234">                hasMoves = true;</span>
            }
<span class="fc" id="L236">            i++;</span>
        }
<span class="fc" id="L238">        return hasMoves;</span>
    }

    /**
     * This method change the color of pieces who are eat.
     *
     * @param position The position
     * @param direction The direction we eat.
     */
    public void eatPieces(Position position, Direction direction) {
<span class="fc" id="L248">        Position pos = new Position(position.getRow(), position.getColumn());</span>
<span class="fc" id="L249">        pos.next(direction);</span>
<span class="fc bfc" id="L250" title="All 2 branches covered.">        while (board.getPiece(pos).getColor() != current.getColor()) {</span>
<span class="fc" id="L251">            current.addPoints(board.getPiece(pos));</span>
<span class="fc" id="L252">            opponent.removePoints(board.getPiece(pos));</span>
<span class="fc" id="L253">            board.getPiece(pos).swapColor();</span>
<span class="fc" id="L254">            pos.next(direction);</span>
        }
<span class="fc" id="L256">    }</span>

    /**
     * This method change the color in all direction who are valid.
     *
     * @param position The position start.
     */
    public void eatPiecesAllDirection(Position position) {
<span class="fc" id="L264">        List&lt;Direction&gt; listDirection = Arrays.asList(Direction.UP,</span>
                Direction.DOWN, Direction.UPLEFT,
                Direction.LEFT, Direction.DOWNLEFT,
                Direction.RIGHT, Direction.DOWNRIGTH,
                Direction.UPRIGTH);

<span class="fc" id="L270">        int i = 0;</span>
<span class="fc bfc" id="L271" title="All 2 branches covered.">        while (i &lt; listDirection.size()) {</span>
<span class="fc bfc" id="L272" title="All 2 branches covered.">            if (isValidMove(position, listDirection.get(i))) {</span>
<span class="fc" id="L273">                eatPieces(position, listDirection.get(i));</span>
            }
<span class="fc" id="L275">            i++;</span>
        }
<span class="fc" id="L277">    }</span>

    /**
     * This method change the current player.
     */
    private void swapPlayers() {
<span class="fc" id="L283">        Player playerswitch = current;</span>
<span class="fc" id="L284">        current = opponent;</span>
<span class="fc" id="L285">        opponent = playerswitch;</span>

<span class="fc" id="L287">    }</span>

    /**
     * This method allows us to get the player current.
     *
     * @return The current.
     */
    public Player getCurrent() {
<span class="fc" id="L295">        return current;</span>
    }

    /**
     * This method allows us to get the player opponent.
     *
     * @return The opponent.
     */
    public Player getOpponent() {
<span class="fc" id="L304">        return opponent;</span>
    }

    /**
     * this method allows us to get the board.
     *
     * @return The board.
     */
    @Override
    public Board getBoard() {
<span class="fc" id="L314">        return board;</span>
    }

    /**
     * This method just put the piece at the position for the tests.
     *
     * @param position The position in the boeard.
     */
    public void putPiece2(Position position,Piece piece) {
<span class="pc bpc" id="L323" title="1 of 2 branches missed.">        if (position == null) {</span>
<span class="nc" id="L324">            throw new IllegalArgumentException(&quot;the position is null&quot;);</span>
        }
<span class="fc" id="L326">        this.board.put(piece, position);</span>
<span class="fc" id="L327">    }</span>
}
</pre><div class="footer"><span class="right">Created with <a href="http://www.eclemma.org/jacoco">JaCoCo</a> 0.7.6.201602180812</span></div></body></html>